diff -ruN uppsrc/CodeEditor/CodeEditor.cpp uppsrc/CodeEditor/CodeEditor.cpp
--- uppsrc/CodeEditor/CodeEditor.cpp	2011-11-15 01:34:59 +0600
+++ uppsrc/CodeEditor/CodeEditor.cpp	2011-11-15 10:43:59 +0600
@@ -34,25 +34,10 @@
 	return isbrkt(c);
 }
 
-void CodeEditor::CheckBraces(const WString& text)
-{
-	for(const wchar *s = text; *s; s++)
-		if(*s == '{' || *s == '(' || *s == '[' || *s == '/' || *s == '*' ||
-		   *s == '}' || *s == ')' || *s == ']') {
-			Refresh();
-			break;
-		}
-}
-
 void CodeEditor::PostInsert(int pos, const WString& text) {
 	if(check_edited)
 		bar.SetEdited(GetLine(pos));
 	if(IsFullRefresh()) return;
-	if(text.GetCount() > 200)
-		Refresh();
-	else
-		CheckBraces(text);
-	// Following code is probable not needed anymore...
 	if(!ScanSyntax(GetLine(pos + text.GetLength()) + 1).MatchHilite(rm_ins)) {
 		if(text.GetLength() == 1 && *text == '(' || *text == '[' || *text == ']' || *text == ')')
 			RefreshChars(RBR);
@@ -64,11 +49,6 @@
 
 void CodeEditor::PreRemove(int pos, int size) {
 	if(IsFullRefresh()) return;
-	if(size > 200)
-		Refresh();
-	else
-		CheckBraces(GetW(pos, size));
-	// Following code is probable not needed anymore...
 	if(size == 1)
 		rmb = Get(pos, 1)[0];
 	else
@@ -80,7 +60,6 @@
 	if(check_edited)
 		bar.SetEdited(GetLine(pos));
 	if(IsFullRefresh()) return;
-	// Following code is probable not needed anymore...
 	if(!ScanSyntax(GetLine(pos) + 1).MatchHilite(rm_ins)) {
 		if(rmb == '(' || rmb == '[' || rmb == ']' || rmb == ')')
 			RefreshChars(RBR);
@@ -168,7 +147,7 @@
 		}
 		if(islbrkt(c))
 			lvl += d;
-		if(isrbrkt(c))
+		else if(isrbrkt(c))
 			lvl -= d;
 		if(lvl <= 0) {
 			highlight_bracket_pos0 = pos0;
@@ -203,8 +182,7 @@
 	int ppos = pos;
 	int li = GetLinePos(pos);
 	WString ln = GetWLine(li);
-	int c = ln[pos];
-	if(c == ')' || c == '}' || c == ']')
+	if(isrbrkt(ln[pos]))
 		CheckBracket(li, pos, ppos, ppos, ln, -1, max(li - 3000, 0));
 }
 
diff -ruN uppsrc/CodeEditor/CodeEditor.h uppsrc/CodeEditor/CodeEditor.h
--- uppsrc/CodeEditor/CodeEditor.h	2011-11-15 01:34:59 +0600
+++ uppsrc/CodeEditor/CodeEditor.h	2011-11-15 10:49:11 +0600
@@ -343,7 +343,6 @@
 	void   FindWildcard();
 	void   ReplaceWildcard();
 	void   InsertWildcard(int c);
-	void   CheckBraces(const WString& text);
 
 	void   SetFound(int fi, int type, const WString& text);
 
diff -ruN uppsrc/CodeEditor/Syntax.cpp uppsrc/CodeEditor/Syntax.cpp
--- uppsrc/CodeEditor/Syntax.cpp	2011-11-06 09:29:09 +0600
+++ uppsrc/CodeEditor/Syntax.cpp	2011-11-15 10:48:15 +0600
@@ -306,23 +306,25 @@
 					}
 					else
 					if(c == ')') {
-						if(brk.GetCount()) {
+						if(brk.GetCount() && brk.Top() == c) {
 							pl--;
 							brk.Drop();
+
+							if(par.GetCount())
+								par.Drop();
+							spar--;
 						}
-						if(par.GetCount())
-							par.Drop();
-						spar--;
 					}
 					else
 					if(c == ']') {
-						if(brk.GetCount()) {
+						if(brk.GetCount() && brk.Top() == c) {
 							bl--;
 							brk.Drop();
+
+							if(par.GetCount())
+								par.Drop();
+							spar--;
 						}
-						if(par.GetCount())
-							par.Drop();
-						spar--;
 					}
 					pc = c;
 				}
